pro extract_matchups2
line=''
openr,unit,'v0951_extracts.csv',/get
readf,unit,line&header=strsplit(line,',',/extr,/preserve_null)
repeat begin
  readf,unit,line
  data=strsplit(line,',',/extr,/preserve_null)
endrep until strmid(data[0],0,10) eq '2002-07-04'
openw,outunit,'matchups2.csv',/get
openw,outunit2,'matchupsGAMLSS.csv',/get
header='timeM,lonM,latM,satid,lonS,latS,dist.km,'+ $
  'timediff.min,chla_hplcM,chlor_a,dln.chlor,icsenz,'+ $
  'icsolz,windspeed,TLg_869,taua_869,Rrs412,Rrs443,'+ $
  'Rrs469,Rrs488,Rrs531,Rrs547,Rrs555,Rrs645,Rrs667,'+ $
  'Rrs678,Rrs748,Rrs859,Rrs869'
for ii=1,32 do header+=',flag'+strtrim(ii,2)
printf,outunit,header
header='dist.km,timediff.min,dln.chlor,icsenz,icsolz,'+ $
  'windspeed,TLg_869,taua_869,Rrs412,Rrs443,Rrs469,'+ $
  'Rrs488,Rrs531,Rrs547,Rrs555,Rrs645,Rrs667,Rrs678,'+ $
  'Rrs748,Rrs859,Rrs869'
for ii=1,32 do header+=',flag'+strtrim(ii,2)
printf,outunit2,header
stats=lonarr(3)
nflags=lonarr(32)
index=1
repeat begin
  year=strmid(data[0],0,4)
  month=strmid(data[0],5,2)
  day=strmid(data[0],8,2)
  hour=strmid(data[0],11,2)
  minute=strmid(data[0],14,2)
  sec=strmid(data[0],17,2)& $
  jul=julday(month,day,year,hour,minute,sec)
  lat=float(data[1])
  latR=lat*!dtor
  slat=sin(latR)
  clat=cos(latR)
  lon=float(data[2])
  lonR=lon*!dtor
  lat0=floor(lat)+90
  lon0=floor(lon)+360*(lon lt 0)
  chlM=data[3]
  if strpos(chlM,':') ne -1 then stop
  if chlM ne '' then begin
    logC=alog(chlM)
    files=file_search(strjoin(['satellite',string(lon0, $
      format='(i3.3)')+':'+string(lon0+1,format='(i3.3)')+'x'+string(lat0, $
      format='(i3.3)')+':'+string(lat0+1,format='(i3.3)'),'0d',year,month,day, $
      'txt/'+data[0]+'*matchup'],'/'),count=nf)
    ;if data[0] eq '2008-07-11T12:00:00Z' then stop
    ;if data[0] eq '2008-07-18T08:40:00Z' then stop
    ;if data[0] eq '2009-10-17T14:22:00Z' then stop
    ;if data[0] eq '2009-10-30T08:15:00Z' then stop
    if index mod 300 eq 0 or nf gt 1 then print,index,nf,strjoin(['satellite',string(lon0, $
      format='(i3.3)')+':'+string(lon0+1,format='(i3.3)')+'x'+string(lat0, $
      format='(i3.3)')+':'+string(lat0+1,format='(i3.3)'),'0d',year,month,day, $
      'txt/'+data[0]+'*matchup'],'/')
    for i=0,nf-1 do begin
      openr,unit1,files[i],/get
      readf,unit1,line
      header1=strsplit(line,',',/extr,/preserve_null)
      if nf gt 1 then grabbed=0
      while ~eof(unit1) do begin
        readf,unit1,line
        if nf gt 1 then if not grabbed then begin
          if i eq 0 then oldline1=line else if line eq oldline1 then break
          grabbed=1
        endif
        data1=strsplit(line,',',/extr,/preserve_null)
        satid=data1[3]
        year=strmid(satid,1,4)
        jd=strmid(satid,5,3)
        juls=julian(jd,year)
        dmy=strsplit(juls,/extr)
        month=dmy[1]
        day=dmy[0]
        hour=strmid(satid,8,2)
        minute=strmid(satid,10,2)
        sec=strmid(satid,12,2)
        dt=strtrim((julday(month,day,year,hour,minute,sec)-jul)*1440.,2)
        lonSR=data1[4]*!dtor
        latSR=data1[5]*!dtor
        a=sin((latSR-latR)/2)^2+clat*cos(latR)*sin((lonSR-lonR)/2)^2 ; Haversine
        distance=strtrim(12742*atan(sqrt(a),sqrt(1-a)),2)
        files2=file_search(files[i]+'_'+satid+'*.extraction',count=nf2)
        if nf2 eq 0 then continue
        if nf2 gt 1 then stop
        openr,unit2,files2,/get
        for j=0,2 do readf,unit2,line
        header2=strsplit(line,',',/extr,/preserve_null)
        chlpos=where(header2 eq 'chlor_a')
        senzpos=where(header2 eq 'senz')
        solzpos=where(header2 eq 'solz')
        zwpos=where(header2 eq 'zwind')
        mwpos=where(header2 eq 'mwind')
        TLgpos=where(header2 eq 'TLg_869')
        tauapos=where(header2 eq 'taua_869')
        l2fpos=where(header2 eq 'l2_flags')
        Rrs412pos=where(header2 eq 'Rrs_412')
        Rrs443pos=where(header2 eq 'Rrs_443')
        Rrs469pos=where(header2 eq 'Rrs_469')
        Rrs488pos=where(header2 eq 'Rrs_488')
        Rrs531pos=where(header2 eq 'Rrs_531')
        Rrs547pos=where(header2 eq 'Rrs_547')
        Rrs555pos=where(header2 eq 'Rrs_555')
        Rrs645pos=where(header2 eq 'Rrs_645')
        Rrs667pos=where(header2 eq 'Rrs_667')
        Rrs678pos=where(header2 eq 'Rrs_678')
        Rrs748pos=where(header2 eq 'Rrs_748')
        Rrs859pos=where(header2 eq 'Rrs_859')
        Rrs869pos=where(header2 eq 'Rrs_869')
        while ~eof(unit2) do begin
          readf,unit2,line
          data2=strsplit(line,',',/extr,/preserve_null)
          chl=data2[chlpos]
          if chl eq '--' then begin
            stats[1]++
            continue
          endif
          if data2[l2fpos] eq '--' then begin
            stats[2]++
            continue
          endif
          dlnchl=alog(chl)-logC
          icsenz=1./cos(data2[senzpos]*!dtor)
          icsolz=1./cos(data2[solzpos]*!dtor)
          wind=strtrim(sqrt(data2[zwpos]^2+data2[mwpos]^2),2)
          flags=intarr(32)
          l2flags=ulong(data2[l2fpos])
          for ii=0,31 do begin
            flags[ii]=(l2flags and 2ul^ii) ne 0
            if flags[ii] then nflags[ii]++
          endfor
          if max(flags) eq 0 then stop
          flags=strtrim(flags,2)
          printf,outunit,strjoin([data[[0,2,1]],satid, $
            data1[4:5],distance,dt,chlM,chl, $
            strtrim([dlnchl,icsenz,icsolz],2),wind, $
            data2[[TLgpos,tauapos,Rrs412pos,Rrs443pos, $
            Rrs469pos,Rrs488pos,Rrs531pos,Rrs547pos, $
            Rrs555pos,Rrs645pos,Rrs667pos,Rrs678pos, $
            Rrs748pos,Rrs859pos,Rrs869pos]],flags],',')
          printf,outunit2,strjoin([distance,dt, $
            strtrim([dlnchl,icsenz,icsolz],2),wind, $
            data2[[TLgpos,tauapos,Rrs412pos,Rrs443pos, $
            Rrs469pos,Rrs488pos,Rrs531pos,Rrs547pos, $
            Rrs555pos,Rrs645pos,Rrs667pos,Rrs678pos, $
            Rrs748pos,Rrs859pos,Rrs869pos]],flags],',')
          stats[0]++
        endwhile
        free_lun,unit2
      endwhile
      free_lun,unit1
    endfor
  endif
  index++
  if index mod 300 eq 0 then print,index,stats
  if eof(unit) then break
  readf,unit,line
  olddata=data
  data=strsplit(line,',',/extr,/preserve_null)
endrep until 0
print,index,stats
for ii=0,31 do print,ii,nflags[ii]
free_lun,unit,outunit,outunit2

end
